#!/bin/bash
#
# QEMU Copy-On-Write (QCOW) library seek offset testing script
#
# Copyright (c) 2010-2012, Joachim Metz <joachim.metz@gmail.com>
#
# Refer to AUTHORS for acknowledgements.
#
# This software is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this software.  If not, see <http://www.gnu.org/licenses/>.
#

EXIT_SUCCESS=0;
EXIT_FAILURE=1;
EXIT_IGNORE=77;

INPUT="input";
TMP="tmp";

LS="ls";
TR="tr";
WC="wc";

QCOW_TEST_SEEK="qcow_test_seek";

test_seek()
{ 
	echo "Testing seek offset of input:" $*;

	./${QCOW_TEST_SEEK} $*;

	RESULT=$?;

	echo "";

	return ${RESULT};
}

if ! test -x ${QCOW_TEST_SEEK};
then
	echo "Missing executable: ${QCOW_TEST_SEEK}";

	exit ${EXIT_FAILURE};
fi

if ! test -d ${INPUT};
then
	echo "No input directory found, to test seek create input directory and place test files in directory.";

	exit ${EXIT_IGNORE};
fi

RESULT=`${LS} ${INPUT}/*.[iI][mM][gG] | ${TR} ' ' '\n' | ${WC} -l`;

if test ${RESULT} -eq 0;
then
	echo "No files found in input directory, to test seek place test files in directory.";

	exit ${EXIT_IGNORE};
fi

for QCOW_FILE in `${LS} ${INPUT}/*.[iI][mM][gG] | ${TR} ' ' '\n'`;
do
	if ! test_seek ${QCOW_FILE};
	then
		exit ${EXIT_FAILURE};
	fi
done

exit ${EXIT_SUCCESS};

